function y = circularconv(x1,x2)
% CIRCULARCONV circularly-convolves sequences x1 and x2

L1 = length(x1); L2 = length(x2);
if L1 ~= L2, error('Sequences of unequal lengths'), end
y = zeros(1,L1);
x2tr = [x2(1) x2(L2:-1:2)];
for n=1:L1
    sh = circularshift(x2tr,n-1);
    h = x1.*sh;
    y(n) = sum(h);
end